from quantulum3 import parser
from quantulum3.load import add_custom_unit
import re

def clean_query(query_raw):
    
    # add space between numbers and charactoers
    query_processed = re.sub(r"([0-9]+(\.[0-9]+)?)",r" \1 ", query_raw).strip()
    
    # remove extra spaces other than 1 space
    query_processed = " ".join(query_processed.split())
    
    return query_processed


def numbers_quantifier(query_raw):
    
    # clean query
    query_rewrite = clean_query(query_raw)
   
    # initiate 
    numbers_quantifier = {}
    parse_status = False
    # start parsing
    try:
        # parse and grab information
        quants = parser.parse(query_rewrite)
        tokens = quants[0].surface
        quantity = quants[0].value
        quantity_span = quants[0].span
        unit_name = quants[0].unit.name
        unit_entity = quants[0].unit.entity.name
        
        # update parse status
        parse_status = True
        
        # update result
        numbers_quantifier["query_raw"] = query_raw
        numbers_quantifier["query_rewrite"] = query_rewrite
        numbers_quantifier["parse_status"] = parse_status
        numbers_quantifier["tokens"] = tokens
        numbers_quantifier["quantity"] = quantity
        numbers_quantifier["quantity_span"] = quantity_span
        numbers_quantifier["unit_name"] = unit_name
        if "size" in query_rewrite:
            numbers_quantifier["unit_entity"] = "size"
        else:
            numbers_quantifier["unit_entity"] = unit_entity
        
    except:
        numbers_quantifier["parse_status"] = parse_status
        
    # edit custom units
    add_custom_unit(name="bottle", surfaces=["bottle"], entity="dimensionless")
    add_custom_unit(name="size", surfaces=["size"], entity="dimensionless")
    add_custom_unit(name="serving", surfaces=["serving"], entity="dimensionless")
    add_custom_unit(name="roll", surfaces=["roll"], entity="dimensionless")
    add_custom_unit(name="pack", surfaces=["pack"], entity="dimensionless")
    add_custom_unit(name="each", surfaces=["ea"], entity="dimensionless")
    
    return numbers_quantifier